/***************************************************************************************************
* Name:      Transfer - Calculate the time elapsed for transfering or riceiving a file             *
* Author:    Alessandro Marinuzzi - [Alecos] - http://www.alecos.it/                               *
* Purpose:   Simulate the transfer of a file obtaining the time elapsed                            *
* Usage:     Open a shell and type "Transfer.exe"                                                  *
* Bugs:      No bug known - This program has been tested severely                                  *
* Compiler:  Microsoft Visual Studio 2010 / CodeBlocks                                             *
* Date:      03.12.2017                                                                            *
* Version:   1.0                                                                                   *
* Revision:  6.0                                                                                   *
***************************************************************************************************/

#include <iostream>
#include <climits>
#include <stdio.h>
#include <math.h>
#include <windows.h>

using namespace std;

long double file_bytes;  // File that you have to transfer in Bytes
long double speed_bytes;  // MBytes, KBytes or Bytes/Sec transfered
long double bytes_total;  // Number of Bytes to transfer each second
long double counter_bytes;  // Groups of Bytes for each second elapsed
long double file_size;  // Input - Size of the file
char identifier;  // Input - Identifier (M = MBytes, K = KBytes, B = Bytes)
char specifier;  // Input - Specifier (T = TBytes, G = GBytes, M = MBytes, K = KBytes, B = Bytes)
int counter_seconds;  // Time elapsed in seconds
int seconds_real;  // Real time elapsed in seconds
int rest_seconds;  // Real time elapsed as rest in seconds out the minute
int minutes_real;  // Real time elapsed in minutes
int rest_minutes;  // Real time elapsed as rest in minutes out the hour
int hours_real;  // Time elapsed in hours
int rest_hours;  // Real time elapsed as rest in hours out the day
int days_real;  // Real time elapsed in days
char choice;  // Quit or go on with the program
static const char version[] = "$VER: Transfer 1.6 (03.12.2017) - By Alecos - [Windows Version]";  // Version of the program

int main () {
  // Infos about the usage
  cout << "Transfer V.1.6 - Date: 03.12.2017 - By Alessandro Marinuzzi\n";
  cout << "Simulate transfer of file giving infos about time elapsed\n";
  while (1) {  // Starts an infinite loop
    /****************************/
    /*  Initialization Section  */
    /****************************/
    file_bytes = 0;  // Sets the variable with the value 0 for each loop
    speed_bytes = 0;  // Sets the variable with the value 0 for each loop
    counter_bytes = 0;  // Sets the variable with the value 0 for each loop
    bytes_total = 0;  // Sets the variable with the value 0 for each loop
    file_size = 0;  // Sets the variable with the value 0 for each loop
    counter_seconds = 0;  // Sets the variable with the value 0 for each loop
    seconds_real = 0;  // Sets the variable with the value 0 for each loop
    rest_seconds = 0;  // Sets the variable with the value 0 for each loop
    minutes_real = 0;  // Sets the variable with the value 0 for each loop
    rest_minutes = 0;  // Sets the variable with the value 0 for each loop
    hours_real = 0;  // Sets the variable with the value 0 for each loop
    rest_hours = 0;  // Sets the variable with the value 0 for each loop
    days_real = 0;  // Sets the variable with the value 0 for each loop
    /************************/
    /*  Input&Data Section  */
    /************************/
    // Insert and store the values
    cout << "Set the transfer speed first - Bytes/Seconds\n";
    cout << "Speed: must be a number bigger than 0\n";
    cout << "Specifier: M = MBytes, K = KBytes, B = Bytes\n";
    cout << "Example: Speed = 5 - Specifier = K -> 5120 Bytes/Sec\n";
    cout << "Speed: ";
    long double speed_temp;
    speed_temp = 0;
    cin >> speed_temp;
    speed_bytes = speed_temp;
    while (cin.fail()) {
      cin.clear();  // Clear input buffer to restore cin to a usable state
      cin.ignore(INT_MAX, '\n');  // Ignore last input
      cout << "Speed must be a number! Try again!\n";  // Warning message
      cout << "Speed: ";
      cin >> speed_temp;
      speed_bytes = speed_temp;
    }
    while (speed_bytes < 1) {  // Check for positive number only
      cin.clear();  // Clear input buffer to restore cin to a usable state
      cin.ignore(INT_MAX, '\n');  // Ignore last input
      cout << "Speed must be bigger than 0! Try again!\n";  // Warning message
      cout << "Speed: ";
      cin >> speed_temp;
      speed_bytes = speed_temp;
    }
    cout << "Specifier: ";  // Specify the speed (MBytes, KBytes o Bytes)
    cin >> identifier;  // Stores the specifier
    switch (identifier) {  // Verify if this specifier is allowed

      case 'M':
      case 'm':
      // Verify if we manage MBytes
      bytes_total = speed_bytes * 1024 * 1024;  // Calculating in Bytes
      // Calculating...
      cout << "Transfer speed: " << static_cast<signed long long int>(bytes_total) << " Bytes/Second!\n";
      break;

      case 'K':
      case 'k':
      // Verify if we manage KBytes
      bytes_total = speed_bytes * 1024;  // Calculating in Bytes
      // Calculating...
      cout << "Transfer speed: " << static_cast<signed long long int>(bytes_total) << " Bytes/Second!\n";
      break;

      case 'B':
      case 'b':
      // Verify if we manage Bytes
      bytes_total = speed_bytes;  // Calculating in Bytes
      // Calculating...
      cout << "Transfer speed: " << static_cast<signed long long int>(bytes_total) << " Bytes/Second!\n";
      break;

      default:
      // If the specifier isn't M or K or B - Error!
      cout << "Specifier not allowed! - Try again!\n";  // Warning message
      continue;
    }
    cout << "Insert the File and the Specifier\n";
    cout << "T = TBytes, G = GBytes, M = MBytes, K = KBytes, B = Bytes\n";
    cout << "Example: File = 400 - Specifier = M\n";
    cout << "The result is a file of 400 MBytes\n";  // Example
    cout << "File: ";
    long double file_temp;
    file_temp = 0;
    cin >> file_temp;
    file_size = file_temp;
    while (cin.fail()) {
      cin.clear();  // Clear input buffer to restore cin to a usable state
      cin.ignore(INT_MAX, '\n');  // Ignore last input
      cout << "File must be a number! Try again!\n";  // Warning message
      cout << "File: ";
      cin >> file_temp;
      file_size = file_temp;
    }
    while (file_size < 1) {  // Check for positive number only
      cin.clear();  // Clear input buffer to restore cin to a usable state
      cin.ignore(INT_MAX, '\n');  // Ignore last input
      cout << "File must be bigger than 0! Try again!\n";  // Warning message
      cout << "File: ";
      cin >> file_temp;
      file_size = file_temp;
    }
    cout << "Specifier: ";  // Asks for the specifier
    cin >> specifier;  // Stores the specifier
    switch (specifier) {  // Verify if this specifier is allowed

      case 'T':
      case 't':
      // Verify if we manage TBytes
      file_bytes = file_size * 1024 * 1024 * 1024 * 1024;  // Calculating in Bytes
      // Calculating...
      cout << "File: " << file_size << " TBytes = " << static_cast<signed long long int>(file_bytes) << " Bytes!\n";
      cout << "Please wait. I'm simulating the transfer...\n";  // Goes on with the simulation...
      break;

      case 'G':
      case 'g':
      // Verify if we manage GBytes
      file_bytes = file_size * 1024 * 1024 * 1024;  // Calculating in Bytes
      // Calculating...
      cout << "File: " << file_size << " GBytes = " << static_cast<signed long long int>(file_bytes) << " Bytes!\n";
      cout << "Please wait. I'm simulating the transfer...\n";  // Goes on with the simulation...
      break;

      case 'M':
      case 'm':
      // Verify if we manage MBytes
      file_bytes = file_size * 1024 * 1024;  // Calculating in Bytes
      // Calculating...
      cout << "File: " << file_size << " MBytes = " << static_cast<signed long long int>(file_bytes) << " Bytes!\n";
      cout << "Please wait. I'm simulating the transfer...\n";  // Goes on with the simulation...
      break;

      case 'K':
      case 'k':
      // Verify if we manage KBytes
      file_bytes = file_size * 1024;  // Calculating in Bytes
      // Calculating...
      cout << "File: " << file_size << " KBytes = " << static_cast<signed long long int>(file_bytes) << " Bytes!\n";
      cout << "Please wait. I'm simulating the transfer...\n";  // Goes on with the simulation...
      break;

      case 'B':
      case 'b':
      // Verify if we manage Bytes
      file_bytes = file_size;  // Calculating in Bytes
      // Calculating...
      cout << "File: " << file_size << " Bytes = " << static_cast<signed long long int>(file_bytes) << " Bytes!\n";
      cout << "Please wait. I'm simulating the transfer...\n";  // Goes on with the simulation...
      break;

      default:
      // If the specifier isn't T or G or M or K or B - Error!
      cout << "Specifier not allowed! - Try again!\n";  // Warning message
      continue;
    }
    /******************************/
    /*  Verify&Calculate Section  */
    /******************************/
    if (bytes_total >= file_bytes) {  // If the file transfered is smaller than the speed - Error!
      cout << "Error! You cannot transfer a file smaller\n";
      cout << "than the transfer speed! Try again!\n";
      continue;
    } else {  // If the file transfered is bigger than the speed -  OK!
      while (counter_bytes < file_bytes) {  // Starts another loop for determining the time elapsed
        counter_bytes += bytes_total;  // + Bytes for each loop for reaching file_bytes
        ++counter_seconds;  // Adds 1 for each loop
        seconds_real = counter_seconds;  // Renames the variable for a better code
        if (seconds_real >= 60) {  // If seconds_real is equal or bigger than 60
          minutes_real = (seconds_real / 60);  // Obtains the minutes in integer
          rest_seconds = (seconds_real % 60);  // Obtains the rest of the minutes in seconds
        }
        if (minutes_real >= 60) {  // If minutes_real is equal or bigger than 60
          hours_real = (seconds_real / 3600);  // Obtains the hours in integer
          rest_minutes = (seconds_real % 3600);  // Obtains the rest of the hours in minutes
          if (rest_minutes >= 60) {  // If the rest of the hours is equal or bigger than 60
            rest_minutes /= 60;  // Obtains the rest in minutes properly
          }
        }
        if (hours_real >= 24) {  // If hours_real is equal or bigger than 24
          days_real = (seconds_real / 86400);  // Obtains the days in integer
          rest_hours = (seconds_real % 86400);  // Obtains the rest of the days in hours
          if (rest_hours >= 24) {  // If the rest of the hours is equal or bigger than 24
            rest_hours /= 3600;  // Obtains the rest in hours properly
          }
        }
      }
    }
    /*********************************/
    /*      Result&Print Section     */
    /*********************************/
    cout << "File transfered: " << static_cast<signed long long int>(file_bytes) << " Bytes\n";  // Infos about the file
    cout << "Time elapsed: ";  // Prepares the infos for printing
    if (days_real > 0) {  // Verify if there are days for calculating the time elapsed
      cout << " -> " << days_real << " days ";  // Prints the days elapsed
      cout << " -> " << rest_hours << " hours ";  // Prints the hours elapsed
      cout << " -> " << rest_minutes << " minutes ";  // Prints the minutes elapsed
      cout << " -> " << rest_seconds << " seconds\n";  // Prints the seconds elapsed
    }
    if ((hours_real > 0) && (hours_real < 24)) {  // Verify if there are hours for calculating the time elapsed
      cout << " -> " << hours_real << " hours ";  // Print the hours elapsed
      cout << " -> " << rest_minutes << " minutes ";  // Print the minutes elapsed
      cout << " -> " << rest_seconds << " seconds\n";  // Print the seconds elapsed
    }
    if ((minutes_real > 0) && (minutes_real < 60)) {  // Verify if there are minutes for calculating the time elapsed
      cout << " -> " << minutes_real << " minutes ";  // Print the minutes elapsed
      cout << " -> " << rest_seconds << " seconds\n";  // Prints the seconds elapsed
    }
    if ((seconds_real > 0) && (seconds_real < 60)) {  // Verify if there are seconds for calculating the time elapsed
      cout << " -> " << seconds_real << " seconds\n";  // Prints the seconds elapsed
    }
    // Asks a choice: quit or go on!
    cout << "Do you want quit? Press Q or q - To go on any key\n";
    cout << "Key: ";
    cin >> choice;  // Stores the choice
    if ((choice == 'Q') || (choice == 'q')) {  // By pressing Q or q the program stops working!
      cout << "Quitted!\n";
      break;
    } else {  // Goes on with the program restarting again the loop
      continue;
    }
  }
  return (0);
}